class CTradeSignals1 {
protected:
    bool m_buy;
    bool m_sell;
    bool natural;
    string symbol;
    ENUM_TIMEFRAMES period;

public:
    void setDefault(string symbol1, ENUM_TIMEFRAMES period1)
    {
        symbol = symbol1;
        period = period1;
    }
    bool SigBuy()
    {
        return (m_buy);
    }
    bool SigSell()
    {
        return (m_sell);
    }
    int Signal()
    {
        if (m_buy) {
            return 1;
        }
        else if (m_sell) {
            return -1;
        }else if(natural){
           return  0;
        }
        else {
            return 0;
        }
    }
};

/*
int  CopyBuffer( 
   int       indicator_handle,     // indicator handle 
   int       buffer_num,           // indicator buffer number 
   int       start_pos,            // start position 
   int       count,                // amount to copy 
   double    buffer[]              // target array to copy 
   );
  
int  iMA( 
   string               symbol,            // symbol name 
   ENUM_TIMEFRAMES      period,            // period 
   int                  ma_period,         // averaging period 
   int                  ma_shift,          // horizontal shift 
   ENUM_MA_METHOD       ma_method,         // smoothing type 
   ENUM_APPLIED_PRICE   applied_price      // type of price or handle 
   );  
   
*/

class CSigMA : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_val[1];
    MqlRates mrate[];
    double p_close;

public:
    bool Init(
        int ma_period, // averaging period
        int ma_shift, // horizontal shift
        ENUM_MA_METHOD ma_method, // smoothing type
        ENUM_APPLIED_PRICE applied_price // type of price or handle
        )
    {

        m_Handle = iMA(symbol, period, ma_period, ma_shift, ma_method, applied_price);
        //m_Handle = iMA(_Symobl, _Period, 10, 0, MODE_EMA, PRICE_CLOSE);
        //   m_Handle = iMA(NULL, PERIOD_CURRENT, MACD_FastPeriod, MACD_SlowPeriod, MACD_SignalPeriod, MACD_Price);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
        ArraySetAsSeries(mrate, true);
        ArraySetAsSeries(m_val, true);

        if (CopyRates(symbol, period, 0, 3, mrate) < 0)
            return (false);

        if (CopyBuffer(m_Handle, 0, 0, 1, m_val))
            return (false);

        p_close = mrate[1].close; // bar 1 close price

        m_buy = (m_val[0] < p_close);
        m_sell = (m_val[0] > p_close);
        natural = false;
        return (true);
    }
    void DeInit()
    {
        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};

// RSI Signal
class CSigi_TrendRSI : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
        m_Handle = iRSI(symbol, period, 14, PRICE_CLOSE,0);
        //iRSI(Symbol(),0,RSIperiod,PRICE_CLOSE,0);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
        ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val < 30 ){
            m_buy = true;
        }else if(val > 70){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};


/*
According to technical analysis, when the stochastic oscillator rises above 80%, the market is overbought, 
and when the oscillator drops below 20%, the market is oversold. 
Thus stochastic can be thought of as strong selling or buying signals, respectively.

int  iStochastic( 
   string           symbol,          // symbol name 
   ENUM_TIMEFRAMES  period,          // period 
   int              Kperiod,         // K-period (number of bars for calculations) 
   int              Dperiod,         // D-period (period of first smoothing) 
   int              slowing,         // final smoothing 
   ENUM_MA_METHOD   ma_method,       // type of smoothing 
   ENUM_STO_PRICE   price_field      // stochastic calculation method 
   );
*/

class CSigi_TrendSTOCH : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       m_Handle = iStochastic(symbol,period,14,3,1,MODE_EMA,STO_LOWHIGH);
        //iRSI(Symbol(),0,RSIperiod,PRICE_CLOSE,0);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val < 20 ){
            m_buy = true;
        }else if(val > 80){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};

/*
Commodity Channel Index (20)	-193.424	Neutral
*/

/*
If the CCI moves outside of the -100 to 100 range and then returns, either a buy or sell signal is generated,
depending on whether the CCI was below -100 (oversold) or above 100 (overbought.)
*/
class CSigi_TrendCCI : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iCCI(symbol,period,20,PRICE_CLOSE);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val < -100 ){
            m_buy = true;
        }else if(val > 100){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
/*
ADX fluctuates from 0 to 100, with readings below 20 indicating a weak trend and readings above 50 signaling a strong trend.

Average Directional Index (14)	39.322	Neutral

*/
class CSigi_TrendADX : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iADX(symbol,period,14);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > 50 ){
            m_buy = true;
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};

/*
Open a sell position when the oscillator is below the zero line forming a peak, and open a buy position when the oscillator is above the zero line forming a gap.


Awesome Oscillator	-2.066	Sell

*/
class CSigi_TrendAwesome : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iAO(symbol,period);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > 0 ){
            m_buy = true;
        }else if(val < 0 ){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
/*
A buy signal is generated when Momentum indicator crosses above zero
A sell signal is generated when Momentum indicator crosses below zero

Momentum (10)	-2.024	Buy

*/
class CSigi_TrendMomentum : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iMomentum(symbol,period,10,PRICE_CLOSE);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > 0 ){
            m_buy = true;
        }else if(val < 0 ){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
/*

 it is considered that when the MACD falls below the signal line it can be regarded as bearish and may well indicate a time to sell,
 whereas when the MACD rises above the signal line indicating a bullish trend which may indicate an upward trend in price.

MACD Level (12, 27)	-0.897	Sell



*/
class CSigi_TrendMACD : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iMACD(symbol,period,12,27,9,PRICE_CLOSE)
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > 0 ){
            m_buy = true;
        }else if(val < 0 ){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
/*

The Williams %R oscillates from 0 to -100. When the indicator produces readings from 0 to -20,
this indicates overbought market conditions. When readings are -80 to -100, it indicates oversold market conditions.



Williams Percent Range (14)	-91.106	Neutral


*/
class CSigi_TrendWPR : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iWPR(symbol,period,14);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > -20 && val < 0 ){
            m_sell = true;
        }else if(val < -100 && val > -80 ){
            m_buy = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};

/*
Bull Bear Power	-2.892	Neutral

*/
class CSigi_TrendBULL : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iBullsPower(symbol,period,13);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val > 0 ){
            m_buy = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
/*
Bull Bear Power	-2.892	Neutral

*/
class CSigi_TrendBEAR : public CTradeSignals1 {
protected:
    int m_Handle;
    double m_Array[1];
    double val;
public:
    bool Init()
    {
       
       m_Handle = iBearsPower(symbol,period,13);
        return (m_Handle != INVALID_HANDLE);
    }
    bool Refresh()
    {
       ArraySetAsSeries(m_Array, true);
        if (CopyBuffer(m_Handle,0,0,1,m_Array) < 0)
            return (false);
        val = m_Array[0];
        if(val < 0 ){
            m_sell = true;
        }else{
          natural = true;
        }
        return (true);
    }
    void DeInit()
    {

        if (m_Handle != INVALID_HANDLE)
            IndicatorRelease(m_Handle);
    }
};
